package com.engine.mzg.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.mzg.service.RecruitMobileService;
import com.engine.mzg.service.impl.RecruitMobileServiceImpl;
import com.engine.mzg.util.ResponseResult;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2024/09/05
 * @version: 1.0
 */
public class RecruitMobileController {

    public RecruitMobileService getService(User user) {
        return ServiceUtil.getService(RecruitMobileServiceImpl.class, user);
    }

    @GET
    @Path("/submitDiscTest")
    @Produces(MediaType.APPLICATION_JSON)
    public String submitDiscTest(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getService(user)::submitDiscTest, params);

    }
    @GET
    @Path("/submitRegist")
    @Produces(MediaType.APPLICATION_JSON)
    public String submitRegist(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getService(user)::submitRegist, params);

    }
}
