package weaver.formmode.mzg.modeexpand.disc;

import weaver.conn.RecordSet;
import weaver.formmode.customjavacode.AbstractModeExpandJavaCodeNew;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.soa.workflow.request.MainTableInfo;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;

import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author:dxfeng
 * @createTime: 2024/09/02
 * @version: 1.0
 */
public class AddDiscExpand extends AbstractModeExpandJavaCodeNew {
    public static final Pattern PATTERN = Pattern.compile("^q([1-9]|[1-3][0-9]|40)$");

    @Override
    public Map<String, String> doModeExpand(Map<String, Object> param) {
        Map<String, String> result = new HashMap<>();
        try {
            int billId;
            int modeId;
            RequestInfo requestInfo = (RequestInfo) param.get("RequestInfo");
            if (requestInfo != null) {
                billId = Util.getIntValue(requestInfo.getRequestid());
                modeId = Util.getIntValue(requestInfo.getWorkflowid());
                if (billId > 0 && modeId > 0) {
                    // 计算各个选项的值
                    int countD = 0;
                    int countI = 0;
                    int countS = 0;
                    int countC = 0;
                    RecordSet rs = new RecordSet();
                    MainTableInfo mainTableInfo = requestInfo.getMainTableInfo();
                    Property[] properties = mainTableInfo.getProperty();
                    for (Property property : properties) {
                        String name = property.getName();
                        Matcher matcher = PATTERN.matcher(name);
                        if (!matcher.matches()) {
                            continue;
                        }
                        if ("0".equals(property.getValue())) {
                            countD++;
                        } else if ("1".equals(property.getValue())) {
                            countI++;
                        } else if ("2".equals(property.getValue())) {
                            countS++;
                        } else if ("3".equals(property.getValue())) {
                            countC++;
                        }
                    }

                    // 更新各个选项的个数
                    rs.executeUpdate("update uf_recruit_disc set dxhj = ? ,ixhj = ?, sxhj = ?, cxhj = ? where id = ? ", countD, countI, countS, countC, billId);

                }
            }
        } catch (Exception e) {
            new BaseBean().writeLog(e);
            result.put("errmsg", "DISC数据统计异常");
            result.put("flag", "false");
        }
        return result;
    }
}
