package weaver.formmode.mzg.modeexpand.interview;

import com.engine.mzg.conn.RecruitCommon;
import com.engine.mzg.enums.EmailTemplateEnum;
import com.engine.mzg.exception.CustomizeRunTimeException;
import com.engine.mzg.util.RecruitUtil;
import com.weaver.formmodel.data.model.Formfield;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.formmode.IgnoreCaseHashMap;
import weaver.formmode.customjavacode.AbstractModeExpandJavaCodeNew;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.soa.workflow.request.MainTableInfo;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author:dxfeng
 * @createTime: 2024/09/10
 * @version: 1.0
 */
public class CancelInterviewFlowExpand extends AbstractModeExpandJavaCodeNew {
    @Override
    public Map<String, String> doModeExpand(Map<String, Object> param) {

        // 取消面试
        Map<String, String> result = new HashMap<>();
        try {
            String billId;
            RequestInfo requestInfo = (RequestInfo) param.get("RequestInfo");
            if (requestInfo != null) {
                billId = requestInfo.getRequestid();
                RecordSet rs = new RecordSet();
                IgnoreCaseHashMap<String, String> mainDataMap = new IgnoreCaseHashMap<>();
                MainTableInfo mainTableInfo = requestInfo.getMainTableInfo();
                Property[] properties = mainTableInfo.getProperty();
                for (Property property : properties) {
                    mainDataMap.put(property.getName(), property.getValue());
                }
                // 发送取消面试邮件
                String emailTitle = "";
                String emailContent = "";
                rs.executeQuery("select yjzt ,yjnr  from uf_recruit_email where mblx =? ", EmailTemplateEnum.INTERVIEW_CANCEL.getValue());
                if (rs.next()) {
                    emailTitle = rs.getString("yjzt");
                    emailContent = rs.getString("yjnr");
                }

                if (StringUtils.isBlank(emailTitle) || StringUtils.isBlank(emailContent)) {
                    throw new CustomizeRunTimeException("请检查邮件模板设置");
                }
                List<Formfield> fieldList = RecruitUtil.getFieldList("uf_recruit_ms");
                Map<String, List<Formfield>> fieldMapList = fieldList.stream().collect(Collectors.groupingBy(Formfield::getFieldname));
                emailContent = RecruitUtil.getReplaceContent(emailContent, fieldMapList, mainDataMap);
                String sendTo = Util.null2String(mainDataMap.get("dzyx"));
                RecruitUtil.sendEmail(sendTo, emailTitle, emailContent);

                // 更新流程、建模状态
                rs.executeUpdate("update uf_recruit_ms set mszt = ? where id = ?", "2", billId);
                // 获取流程表名
                String flowTableInterview = RecruitCommon.getSettingValue("FLOW_TABLE_INTERVIEW");
                String requestId = Util.null2String(mainDataMap.get("mslcid"));
                rs.executeUpdate("update " + flowTableInterview + " set mszt = ? where requestId = ? ", "2", requestId);

            }
        } catch (Exception e) {
            new BaseBean().writeLog(e);
            result.put("errmsg", e.getMessage());
            result.put("flag", "false");
        }
        return result;

    }
}
